#include "testlib.h"
#include <iostream>

using namespace std;

string mode;

vector<string> mods = {"random", "inc", "dec", "copy", "updown", "nochange", "updownl", "smallbig"};

vector<string> umods = {"random", "inc", "dec", "bintree", "same"};

map<string, string> params;

int m;

int s[2000000];

int g[2000000];

bool smallbig = false;

void fillu(int n, int l, int r, string umode, bool rev) {
	if (umode == "any") {
		umode = rnd.any(umods);
	}
	if (umode == "random" || umode == "inc" || umode == "dec") {
		for (int i = 0; i < n; i++) {
			g[i] = rnd.next(l, r);
		}
	}
	if (umode == "inc" || umode == "dec") {
		sort(g, g + n);
	}
	if (umode == "dec") {
		reverse(g, g + n);
	}
	if (umode == "same") {
		int c = rnd.next(l, r);
		for (int i = 0; i < n; i++) {
			g[i] = c;
		}
	}
	if (umode == "bintree") {
		int lg = 0;
		while ((1 << lg) <= n) {
			lg++;
		}
		vector<int> v(lg);
		if (r - lg < l) {
			for (int i = 0; i < lg; i++) {
				v[i] = rnd.next(l, r);
			}
			sort(v.begin(), v.end());
		} else {
			for (int i = 0; i < lg; i++) {
				v[i] = rnd.next(l, r - lg);
			}
			sort(v.begin(), v.end());
			for (int i = 0; i < lg; i++) {
				v[i] += i;
			}
		}
		if (rev) {
			reverse(v.begin(), v.end());
		}
		for (lg = 0; (1 << lg) <= n; lg++) {
			for (int i = (1 << lg) - 1; i < n; i += (1 << (lg + 1))) {
				g[i] = v[lg];
			}
		}
	}
}

void fill(int l, int r) {
	auto currmode = mode;
	if (currmode == "any") {
		currmode = rnd.any(mods);
	}
	if (s[l] == 0) {
		s[l] = rnd.next(1, m);
	}
	if (currmode == "random") {
		for (int i = l + 1; i <= r; i++) {
			s[i] = rnd.next(1, m);
		}
	}
	if (currmode == "inc") {
		for (int i = l + 1; i <= r; i++) {
			s[i] = rnd.next(s[l], m);
		}
		sort(s + l, s + r + 1);
	}
	if (currmode == "dec") {
		for (int i = l + 1; i <= r; i++) {
			s[i] = rnd.next(1, s[l]);
		}
		sort(s + l, s + r + 1);
		reverse(s + l, s + r + 1);
	}
	if (currmode == "nochange") {
		int ll = 1, rr = m;
		if (l > 0) {
			if (s[l] < s[l - 1]) {
				rr = s[l];
			}
			if (s[l] > s[l - 1]) {
				ll = s[l];
			}
		}
		for (int i = l + 1; i <= r; i++) {
			if (rnd.next(5) == 0) {
				s[i] = s[i - 1];
			} else {
				s[i] = rnd.next(ll, rr);
			}
			ll = 1;
			rr = m;
			if (s[i] < s[i - 1]) {
				rr = s[i];
			}
			if (s[i] > s[i - 1]) {
				ll = s[i];
			}
		}
	}
	if (currmode == "copy") {
		int t;
		if (params.count("diff")) {
			t = stoi(params["diff"]);
		} else {
			if (rnd.next(2) == 0 || m == 1) {
				t = rnd.next(1, 20);
			} else {
				t = rnd.next(1, m / 2);
			}
			if (t > m / 2) {
				t = m / 2;
			}
		}
		bool f = rnd.next(2);
		if (f && s[l] == 1) {
			f = 0;
		}
		if (!f && s[l] == m) {
			f = 1;
		}
		for (int i = l + 1; i <= r; i++) {
			f = !f;
			if (f) {
				s[i] = rnd.next(s[i - 1] + 1, min(m, s[i - 1] + t));
			} else {
				s[i] = rnd.next(max(1, s[i - 1] - t), s[i - 1] - 1);
			}
		}
	}
	if (currmode == "smallbig") {
		s[r] = rnd.next(1, m);
		r--;
		l++;
		if (r - l <= 5) {
			for (int i = l; i <= r; i++) {
				s[i] = rnd.next(1, m);
			}
			return;
		}
		if (l - r % 2 == 0) {
			s[l] = rnd.next(1, m);
			l++;
		}
		int a = rnd.next(1, m);
		int b = rnd.next(1, m);
		if (b == a) {
		    b = a + 1;
		    if (b > m) {
		        b--;
		        a--;
		    }
		}
		if (a > b) {
		    swap(a, b);
		}
		if (smallbig) {
		    swap(a, b);
		}
		smallbig = !smallbig;
		s[l] = a;
		s[r] = b;
		for (int i = l + 1; i < r; i++) {
			if ((i - l) % 2 == 1) {
				s[i] = a;
			} else {
				s[i] = b;
			}
		}
	}
	if (currmode == "updownl") {
		if (l + 2 >= r) {
			s[l + 1] = rnd.next(1, m);
			s[r] = rnd.next(1, m);
			return;
		}
		l += 2;
	}
	if (currmode == "updown" || currmode == "updownl") {
		string umode = "any", dmode = "any";
		if (params.count("umode")) {
			umode = params["umode"];
		}
		if (params.count("dmode")) {
			dmode = params["dmode"];
		}
		int d = rnd.next(2, m);
		if (params.count("divide")) {
			d = stoi(params["divide"]);
		}
		string border = rnd.any(vector<string>({"stable", "stable", "random"}));
		if (params.count("border")) {
			border = params["border"];
		}
		if (border == "stable") {
			s[l] = d;
			s[r] = d;
		} else {
			s[l] = rnd.next(1, m);
			s[r] = rnd.next(1, m);
		}
		int n1 = (r - l) / 2;
		int n2 = (r - l - 1) / 2;
		bool mx = rnd.next(0, 1);
		if (mx) {
			fillu(n1, d, m, umode, 1);
		} else {
			fillu(n1, 1, d - 1, dmode, 0);
		}
		for (int i = 0; i < n1; i++) {
			s[l + 1 + i * 2] = g[i];
		}
		if (mx) {
			fillu(n2, 1, d - 1, dmode, 0);
		} else {
			fillu(n2, d, m, umode, 1);
		}
		for (int i = 0; i < n2; i++) {
			s[l + 2 + i * 2] = g[i];
		}
	}
	if (currmode == "updownl") {
		s[l - 1] = rnd.next(min(s[l], s[l - 2]), max(s[l], s[l - 2]));
	}
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	for (int i = 1; i < argc; i++) {
		string s = string(argv[i]);
		if (s.find("=") != string::npos) {
			auto pos = s.find("=");
			params[s.substr(0, pos)] = s.substr(pos + 1);
		}
	}
	int n = stoi(params["n"]);
	int t = 1;
	if (params.count("t")) {
		t = stoi(params["t"]);
	}
	m = 1e9;
	if (params.count("m")) {
		m = stoi(params["m"]);
	}
	int k = 1;
	if (params.count("k")) {
		k = stoi(params["k"]);
	}
	mode = params["mode"];
	vector<int> v(k - 1);
	for (int i = 0; i < k - 1; i++) {
		v[i] = rnd.next(1, n - k);
	}
	sort(v.begin(), v.end());
	for (int i = 0; i < k - 1; i++) {
		v[i] += i;
	}
	v.push_back(n - 1);
	int l = 0;
	smallbig = rnd.next(2);
	for (int i = 0; i < k; i++) {
		fill(l, v[i]);
		l = v[i];
	}
	cout << n << ' ' << t << '\n';
	for (int i = 0; i < n; i++) {
		cout << s[i];
		if (i < n - 1) {
			cout << ' ';
		}
	}
	cout << '\n';
}
