#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 500 * 1000 + 228;

struct ev {
    int l;
    int r;
    int lvl;
};

int n, t;
int arr[MAX_N];
int ans = 0;
vector<ev> evs;

int get_mid(const int* arr) {
    if (arr[0] < arr[1]) {
        if (arr[2] < arr[1]) {
            return arr[0] < arr[2] ? arr[2] : arr[0];
        }
    } else {
        if (arr[2] > arr[1]) {
            return arr[0] < arr[2] ? arr[0] : arr[2];
        }
    }
    return arr[1];
}

void solve(int l, int r, int lvl) {
    ans = max(ans, lvl);
    if (r - l < 3) {
        return;
    }

    int pr_val = get_mid(arr + l);
    bool ch = false;
    for (int i = l + 1; i < r - 2; ++i) {
        int cur = get_mid(arr + i);
        ch |= (arr[i] != pr_val);
        arr[i] = pr_val;
        pr_val = cur;
    }
    ch |= (arr[r - 2] != pr_val);
    arr[r - 2] = pr_val;

    if (ch) {
        int prv = l;
        for (int i = l + 1; i < r; ++i) {
            if (arr[i] == arr[i - 1]) {
                evs.push_back({prv, i, lvl + 1});
                prv = i;
            }
        }
        evs.push_back({prv, r, lvl + 1});
    }
}

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d%d", &n, &t);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &arr[i]);
    }

    evs.push_back({0, n, 0});
    for (int i = 0; i < (int)evs.size(); ++i) {
        solve(evs[i].l, evs[i].r, evs[i].lvl);
    }

    printf("%d\n", ans);
    if (t) {
        for (int i = 0; i < n; ++i) {
            printf("%d%c", arr[i], " \n"[i == n - 1]);
        }
    }

    return 0;
}

