#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")

#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 500 * 1000 + 228;

struct ev {
    int l;
    int r;
    int lvl;
};

int n, t;
int arr[MAX_N];
int coord[MAX_N];
int ans = 0;
vector<ev> evs;

template<typename T>
class Solver {
public:
    T arr[MAX_N];
    T arr2[MAX_N];

    void init() {
        for (int i = 0; i < n; ++i) {
            arr[i] = (T)::arr[i];
        }
    }

    void write() {
        for (int i = 0; i < n; ++i) {
            ::arr[i] = arr[i];
        }
    }

    void solve_all() {
        init();
        ans = 0;
        evs.clear();
        evs.push_back({0, n, 0});
        for (int i = 0; i < (int)evs.size(); ++i) {
            solve(evs[i].l, evs[i].r, evs[i].lvl);
        }
        write();
    }

    T get_mid(const T* arr) {
        if (arr[0] < arr[1]) {
            if (arr[2] < arr[1]) {
                return arr[0] < arr[2] ? arr[2] : arr[0];
            }
        } else {
            if (arr[2] > arr[1]) {
                return arr[0] < arr[2] ? arr[0] : arr[2];
            }
        }
        return arr[1];
    }

    void solve(int l, int r, int lvl) {
        ans = max(ans, lvl);
        if (r - l < 3) {
            return;
        }

        if (clock() > 1.8 * CLOCKS_PER_SEC) {
            while (l + 1 < r && arr[l] == arr[l + 1]) {
                ++l;
            }
            while (l < r - 1 && arr[r - 2] == arr[r - 1]) {
                --r;
            }
            if (r - l < 3) {
                return;
            }
            ans += (r - l - 1) / 2;
            if (arr[l] == arr[r - 1]) {
                for (int j = l; j < r; ++j) {
                    arr[j] = arr[l];
                }
            } else {
                int m = (l + r) / 2;
                for (int j = l; j < m; ++j) {
                    arr[j] = arr[l];
                }
                for (int j = m; j < r; ++j) {
                    arr[j] = arr[r - 1];
                }
            }
            return;
        }

        bool ch = false;
        for (int i = l + 1; i < r - 1; ++i) {
            arr2[i] = get_mid(arr + i - 1);
            ch |= (arr[i] != arr2[i]);
        }
        memcpy(arr + l + 1, arr2 + l + 1, (r - l - 2) * sizeof(T));

        if (ch) {
            if ((lvl & 511) != 0) {
                while (l + 1 < r && arr[l] == arr[l + 1]) {
                    ++l;
                }
                while (l < r - 1 && arr[r - 2] == arr[r - 1]) {
                    --r;
                }
                evs.push_back({l, r, lvl + 1});
                return;
            }
            int prv = l;
            for (int i = l + 1; i < r; ++i) {
                if (arr[i] == arr[i - 1]) {
                    evs.push_back({prv, i, lvl + 1});
                    prv = i;
                }
            }
            evs.push_back({prv, r, lvl + 1});
        }
    }
};

Solver<bool> solver0;
Solver<unsigned char> solve1;
Solver<unsigned short> solve2;
Solver<unsigned int> solve3;

int main() {
#ifdef CH_EGOR
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#else
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
#endif

    scanf("%d%d", &n, &t);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &arr[i]);
        coord[i] = arr[i];
    }

    sort(coord, coord + n);
    int sz = unique(coord, coord + n) - coord;
    for (int i = 0; i < n; ++i) {
        arr[i] = lower_bound(coord, coord + sz, arr[i]) - coord;
    }

    if (sz <= 2) {
        solver0.solve_all();
    } else if (sz <= (1 << 8)) {
        solve1.solve_all();
    } else if (sz <= (1 << 16)) {
        solve2.solve_all();
    } else {
        solve3.solve_all();
    }

    printf("%d\n", ans);
    if (t) {
        for (int i = 0; i < n; ++i) {
            printf("%d%c", coord[arr[i]], " \n"[i == n - 1]);
        }
    }

    return 0;
}

